//avertissement :
//pour que cet exemple fonctionne, le fichier XP.txt doit tre dans le mme dossier
//que l'exe de l'application

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellApi;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    GroupBox3: TGroupBox;
    ListBox2: TListBox;
    GroupBox4: TGroupBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    GroupBox5: TGroupBox;
    Memo1: TMemo;
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
    procedure ongletsXP;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  Liste : TStrings;  //liste des titres de fentres et des onglets
  pos_liste : Integer;
  param :  String;

procedure TForm1.FormCreate(Sender: TObject);
var
  i : integer;
begin
  Liste := TStringList.create;
  if Win32Platform = VER_PLATFORM_WIN32_NT then  //pour vrifier la version de Win
  begin
    Liste.LoadFromFile('XP.txt');  //on rcupre le contenu du fichier dans la liste
    for i := 0 to 23 do ListBox1.Items.Add(Liste[i]); //on remplit le listbox
    ListBox1.ItemIndex := 0;
    Button1.Caption := ListBox1.Items[0];
    Button2.Caption := ListBox1.Items[0];
  end else begin
    ShowMessage('Le systme n''est pas du type Windows NT/2000/XP.'#13'Essayez d''utiliser "Lanceur98".');
    application.terminate;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);  //quitter
begin
  PostMessage(Application.Handle, WM_QUIT, 0, 0);
  //ou: SendMessage(Application.Handle, WM_SYSCOMMAND,SC_CLOSE,0);
end;

procedure TForm1.Button3Click(Sender: TObject);  //Mettre le moniteur en veille
begin
  SendMessage(Application.Handle, WM_SYSCOMMAND,SC_SCREENSAVE,0);
end;

procedure TForm1.ongletsXP;  //voir le fichier XP.txt
var
  i : integer;
begin  //si l'applette contient plusieurs onglets ils s'affichent dans le listbox2
  case ListBox1.ItemIndex of
  1 : begin
        pos_liste := 25;
        for i := 0 to 5 do ListBox2.Items.Add(Liste[25 +i]);  //systme
      end;
  2 : begin
         pos_liste := 32;
         for i := 0 to 3 do ListBox2.Items.Add(Liste[32 +i]);  //affichage
      end;
  3 : begin
        pos_liste := 37;
        for i := 0 to 6 do ListBox2.Items.Add(Liste[37 +i]);  //internet
      end;
  4 : begin
        pos_liste := 45;
        for i := 0 to 4 do ListBox2.Items.Add(Liste[45 +i]);  //son & audio
      end;
  5 : begin
        pos_liste := 51;
        for i := 0 to 1 do ListBox2.Items.Add(Liste[51 +i]);  //date & heure
      end;
  6 : begin
        pos_liste := 54;
        for i := 0 to 4 do ListBox2.Items.Add(Liste[54 +i]);  //souris
      end;
  16 : begin
         pos_liste := 60;
         for i := 0 to 1 do ListBox2.Items.Add(Liste[60 +i]);  //opt. rgionales
       end;
  end;
  ListBox2.ItemIndex := 0;
end;

procedure TForm1.ListBox1Click(Sender: TObject);  //action du bouton Ouvrir
begin
  ListBox2.Clear;
  //il y a qqchose de "trouble" avec Proprits de l'affichage
  //impossible d'accder  l'onglet Apparence ?!... d'o la ligne suivante
  if ListBox1.ItemIndex = 2 then param := '-1' else param := '0';
  Button1.Caption := ListBox1.Items[ListBox1.ItemIndex];
  Button2.Caption := ListBox1.Items[ListBox1.ItemIndex];
  ongletsXP;
end;

procedure TForm1.ListBox2Click(Sender: TObject);  //Onglet
begin
  //mme remarque que ci-dessus
  if ListBox1.ItemIndex <> 2 then param := IntToStr(ListBox2.ItemIndex)
    else if ListBox2.ItemIndex < 3 then param := IntToStr(ListBox2.ItemIndex -1)
      else param := '4';
end;

procedure TForm1.Button1Click(Sender: TObject);  //btn Ouvrir
var
  cmd : String;
begin
  case ListBox1.ItemIndex of
    //commande pour WinExec ci-dessous
    0 : cmd := 'rundll32.exe shell32,Control_RunDLL';  //Panneau Configuration
    1 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL sysdm.cpl,,' + param;  //Proprits systme
    2 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL desk.cpl,,' + param;  //Proprits de l'affichage
    3 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl,,' + param;  //proprits de internet
    4 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl,,' + param;  //Proprits de sons & priph audio
    5 : cmd := 'rundll32.exe shell32.dll, Control_RunDLL timedate.cpl,,' + param;  //proprits de date et heure
    6 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL main.cpl,,' + param;  //Proprits souris
    7 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL powercfg.cpl';  //Proprits alimentation
    8 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL appwiz.cpl';  //Ajot suppression de programmes
    9 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL hdwwiz.cpl';  //Ajot suppr de matriel
    10 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL nusrmgr.cpl';  //Comptes utilisateurs
    11 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL ncpa.cpl';  //Connexions rseau
    12 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL speech.cpl';  //Speech
    13 : cmd := 'SNDVOL32.EXE';  //Contrle de lecture (volumes)
    14 : cmd := 'rundll32.exe shell32.dll, SHHelpShortcuts_RunDLL PrintersFolder';  //Imprimantes et tlcopieurs
    15 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL modem.cpl';  //Options de modems et tlphonie
    16 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL intl.cpl,,' + param;  //Options rgionales & linguistiques
    17 : cmd := 'rundll32.exe shell32.dll,Control_RunDLL joy.cpl';  //contrleur de jeux
    //lancement avec ShellExecute
    18 : ShellExecute(handle, 'explore', '...', NIL, NIL, SW_SHOWNORMAL);  //Poste de travail 'open',0 NIL
    19 : ShellExecute(handle, NIL, 'IEXPLORE.EXE', NIL, NIL, SW_SHOWNORMAL);  //IE
    20 : ShellExecute(handle, NIL, 'msimn.exe', NIL, NIL, SW_SHOWNORMAL);  //Outlook
    21 : ShellExecute(handle, NIL, 'notepad.exe', NIL, NIL, SW_SHOWNORMAL);  //Bloc-notes
    22 :  ShellExecute(handle, NIL, 'wmplayer.exe', NIL, NIL, SW_SHOWNORMAL);  //W Media Player
    23 : ShellExecute(handle, NIL, 'osk.exe', NIL, NIL, SW_SHOWNORMAL);  //Clavier visuel
  end;
  if ListBox1.ItemIndex < 18 then
  begin
    WinExec(PChar(cmd),SW_SHOW);  //lancement avec WinExec
    Memo1.Text := 'WinExec(' + cmd + ', SW_SHOW);';
  end else Memo1.Text := 'ShellExecute(handle, NIL, ''NOM_PROGRAMME.exe'', NIL, NIL, SW_SHOWNORMAL);';
end;

procedure TForm1.Button2Click(Sender: TObject);  //btn Fermer
var
  titre : String;
begin
  case ListBox1.ItemIndex of
    0 : titre := 'Panneau de configuration';
    1 : titre := 'Proprits systme';  //proprits systme
    2 : titre := 'Proprits de Affichage';  //Proprits de l'affichage
    3 : titre := 'Proprits de internet';  //proprits de internet
    4 : titre := 'Proprits de Sons et priphriques audio';  //Proprits de sons & priph audio
    5 : titre := 'Proprits de Date et heure';  //proprits de date et heure
    6 : titre := 'Proprits de Souris';  //Proprits souris
    7 : titre := 'Proprits de Options d''alimentation';  //Proprits alimentation
    8 : titre := 'Ajouter ou supprimer des programmes';  //Ajot suppression de programmes
    9 : titre := 'Assistant Ajout de matriel';  //Ajot suppr de matriel
    10 : titre := 'Comptes d''utilisateurs';  //Comptes utilisateurs
    11 : titre := 'Connexions rseau';  //Connexions rseau
    12 : titre := 'Speech Properties';  //Speech
    13 : titre := 'Contrle de lecture';  //Contrle de lecture
    14 : titre := 'Imprimantes et tlcopieurs';  //Imprimantes et tlcopieurs
    15 : titre := 'Options de modems et tlphonie';  //Options de modems et tlphonie
    16 : titre := 'Options rgionales et linguistiques';  //Options rgionales & linguistiques
    17 : titre := 'Contrleurs de jeu';  //contrleur de jeux
    18 : titre := 'Poste de travail';
    19 : PostMessage(FindWindow('IEFRAME', nil) ,WM_CLOSE, 0, 0);  //IE, autres : modifier
    20 : titre := 'Bote de rception - Outlook Express';  //Outlook express
    //21 : PostMessage(FindWindow(NIL, 'Context'),WM_CLOSE,0,0);  //('TApplication', 'Context')
    21 : PostMessage(FindWindow('NotePad', nil) ,WM_CLOSE, 0, 0);
    22 : titre := 'Lecteur Windows Media';  //
    23 : titre := 'Clavier visuel';  //Clavier visuel
  end;
  if (ListBox1.ItemIndex = 19) or (ListBox1.ItemIndex = 21) then
    Memo1.Text := 'PostMessage(FindWindow(''CLASSE'', nil), WM_CLOSE, 0, 0);'
  else begin
    PostMessage(FindWindow(nil, PChar(titre)),WM_CLOSE,0,0);
    Memo1.Text := 'PostMessage(FindWindow(nil, ''TITRE_FENTRE''), WM_CLOSE, 0, 0);';
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Liste.free;  //on libre la liste
end;

end.
